/*
 * i2c_interface.h
 *
 *  Created on: 2018312
 *      Author: admin
 */

#ifndef I2C_INTERFACE_H_
#define I2C_INTERFACE_H_

#include <cyu3system.h>
#include <cyu3os.h>
#include <cyu3dma.h>
#include <cyu3error.h>
#include <cyu3uart.h>
#include <cyu3i2c.h>
#include <cyu3types.h>
#include <cyu3gpio.h>
#include <cyu3utils.h>

typedef int (*PTRFUNWrite)(void*, uint32_t, uint32_t);
typedef int (*PTRFUNRead)(void*, uint32_t, uint32_t*);
typedef int (*PTRFUNWriteBurst)(void*, uint32_t, uint8_t*, uint32_t size);
typedef int (*PTRFUNReadBurst)(void*, uint32_t, uint8_t*, uint32_t size);

#define UINT32BYTE0(a) ((uint8_t)(a & 0x00000000FF))
#define UINT32BYTE1(a) ((uint8_t)((a & 0x000000FF00) >> 8))
#define UINT32BYTE2(a) ((uint8_t)((a & 0x0000FF0000) >> 16))
#define UINT32BYTE3(a) ((uint8_t)((a & 0x00FF000000) >> 24))
#define UINT32BYTE4(a) ((uint8_t)((a & 0xFF00000000) >> 32))
typedef struct I2COBJ
{
	uint8_t slave_addr;
	uint8_t addr_len;
	uint8_t data_len;
	PTRFUNWrite Write;
	PTRFUNRead Read;
	PTRFUNWriteBurst WriteBurst;
	PTRFUNReadBurst ReadBurst;
}I2COBJ_t;

int i2c_interface_init(I2COBJ_t *pObj, uint8_t slave_addr, uint8_t addr_len, uint8_t data_len);

#endif /* I2C_INTERFACE_H_ */
